open Error
open Types

(* The four following functions deconstruct the toplevel constructor of
   type expressions and repport an error if the type does not have the
   expected shape *)

val deconstruct_arrow :
  Export.env -> location -> ftype -> ftype * ftype

val deconstruct_quantifier : quantifier -> 
  Export.env -> location -> ftype -> ftype_context

val deconstruct_record :
  Export.env -> location -> ftype -> ftype Atom.AtomMap.t

val deconstruct_record_label :
  Export.env -> location -> Atom.AtomMap.key -> ftype -> ftype

(* [matching_type p loc cty ty] wraps the call to 
   [Types.matching cty ty] to report an error if [ty] is not
   an instance of [cty] and always pick some witness *)
val matching :
  Export.env -> location -> ftype_context -> ftype -> ftype 
